/////////////////Present Mode Import/////////////////

import javax.swing.JFrame;
import java.awt.*;
import java.lang.Object ;
import java.awt.Color ;

/////////////////////Aduio////////////////////

import ddf.minim.*;
Minim minim;

AudioSample sndJump,sndCoin,life,click,tick;
AudioPlayer titleMusic,customizeMusic,gameMusic,gameOver,howToCredits;

////////////////////Images////////////////////

PImage painter,iconHead,worldBackground,worldBackgroundFar;
PImage ground,grass,killBlock,earth,cloud,cloudFar,curveRight,curveLeft,groundEdgeL,groundEdgeR,bottomEarth,sideL,sideR,wallThin,solidThin;
PImage characterStart,characterLegs,characterLegsRun1,characterLegsRun2,characterEyelids;

static final int coinCount = 4, titleCount = 4;
PImage [] coin = new PImage[coinCount],ragzTitle = new PImage[titleCount];

////////////////Character Image Arrays/////////////

static final int sockCount=10,shoeCount=9,undiesCount=12,pantsCount=25,watchCount=2,handsCount=4,hatCount=3,underShirtCount=35,overShirtCount=49,tieCount=14,sweaterVestCount=9,collarCount=49,jacketCount=15,outerCoatCount=11,scarfCount=5;

PImage[] sock = new PImage[sockCount],shoe = new PImage[shoeCount],undies = new PImage[undiesCount],pants = new PImage[pantsCount],
         underShirt = new PImage[underShirtCount],watch = new PImage[watchCount],hands = new PImage[handsCount],hat = new PImage[hatCount],
         overShirt = new PImage[overShirtCount],tie = new PImage[tieCount],sweaterVest = new PImage[sweaterVestCount],collar = new PImage[collarCount],
         jacket = new PImage[jacketCount],outerCoat = new PImage[outerCoatCount],scarf = new PImage[scarfCount], sockRun1 = new PImage[sockCount],
         sockRun2 = new PImage[sockCount],shoeRun1 = new PImage[shoeCount],shoeRun2 = new PImage[shoeCount],undiesRun1 = new PImage[undiesCount],
         undiesRun2 = new PImage[undiesCount],pantsRun1 = new PImage[pantsCount],pantsRun2 = new PImage[pantsCount];

//////////////////////Font///////////////////

PFont bitFont;//8bit font

/////////Global integers/floats/booleans//////////

String versionNumber = "VERSION: R-1.1.0";

boolean start,select,choice,pause,holdingUp,holdingRight,holdingLeft,holdingSpace = false;

int layerSelect = 0;
int sockCall,shoeCall,undiesCall,pantsCall,underShirtCall,watchCall,handsCall,hatCall,overShirtCall,tieCall,sweaterVestCall,collarCall,jacketCall,outerCoatCall,scarfCall = 0;

static final int characterSizeX = 114;
static final int characterSizeY = 256;
static final int characterGameSizeX = 38;
static final int characterGameSizeY = 86;

final float GRAVITY_POWER = 0.5;
float cameraOffsetX;

float blink = 0;
float blinker;

int flash;
int fade = 75;
int titleFrame;
int lives = 3;
int menuDelay = 0;
int menuSelect = 0;

int level = 0;//Level - 0: Title Screen
              //level - 1: Customize Screen
              //level - 2: Level Lead in screen
              //Level - 3: GamePlay Screen
              //Level - 4: Game Over Screen
              
static final int LEVEL_TITLE = 0;
static final int LEVEL_CUSTOMIZE = 1;
static final int LEVEL_LEADIN = 2;
static final int LEVEL_GAME = 3;
static final int LEVEL_GAMEOVER = 4;
static final int LEVEL_HOWTO = 5;
static final int LEVEL_CREDITS = 6;

//////////////////////Classes/////////////////////

Player thePlayer = new Player();
World theWorld = new World();

//Present Mode Color Change Function
//void setPresentBG (int r, int g, int b) {
//((JFrame) frame).getContentPane().setBackground(new Color(r, g, b));
//}

void setup() {
  size(800,600,P2D);
  noSmooth();
  ((PGraphicsOpenGL)g).textureSampling(3);

  //setPresentBG (0,255,0) ;
///////////////////Load Font//////////////////////

bitFont = createFont("ARCADEPIX.TTF",20,false);// 8 bit font
textFont(bitFont);

//////////////////Load Images/////////////////////

  painter = loadImage("painter.gif");
  iconHead = loadImage("iconHead.gif");
  ground = loadImage("ground.gif");
  grass = loadImage("grass.gif");
  killBlock = loadImage("killBlock.gif");
  earth = loadImage("earth.gif");
  cloud = loadImage("cloud.gif");
  cloudFar = loadImage("cloudFar.gif");
  curveLeft = loadImage("curve.gif");
  curveRight = loadImage("curveR.gif");
  groundEdgeL = loadImage("groundEdgeL.gif");
  groundEdgeR = loadImage("groundEdgeR.gif");
  bottomEarth = loadImage("bottomEarth.gif");
  sideL = loadImage("wall.gif");
  sideR = loadImage("wallR.gif");
  wallThin = loadImage("wallThin.gif");
  solidThin = loadImage("solidThin.gif");
  characterStart = loadImage("character.gif");
  characterLegs = loadImage("characterLegs.gif");
  characterLegsRun1 = loadImage("characterLegsRun1.gif");
  characterLegsRun2 = loadImage("characterLegsRun2.gif");
  characterEyelids = loadImage("characterEyelids.gif");
  worldBackground = loadImage("worldBackground.gif");
  worldBackgroundFar = loadImage("worldBackgroundFar.gif");

/////////////////Asynchronous Image Load/////////////
  
for (int i = 0; i < sockCount; i++){
    sock[i] = loadImage("sock_"+i+".gif");
    sockRun1[i] = loadImage("sockRun1_"+i+".gif");
    sockRun2[i] = loadImage("sockRun2_"+i+".gif");
  }
for (int i = 0; i < shoeCount; i++){
    shoe[i] = loadImage("shoe_"+i+".gif");
    shoeRun1[i] = loadImage("shoeRun1_"+i+".gif");
    shoeRun2[i] = loadImage("shoeRun2_"+i+".gif");
  }
for (int i = 0; i < undiesCount; i++){
    undies[i] = loadImage("undies_"+i+".gif");
    undiesRun1[i] = loadImage("undiesRun1_"+i+".gif");
    undiesRun2[i] = loadImage("undiesRun2_"+i+".gif");
  }
for (int i = 0; i < pantsCount; i++){
    pants[i] = loadImage("pants_"+i+".gif");
    pantsRun1[i] = loadImage("pantsRun1_"+i+".gif");
    pantsRun2[i] = loadImage("pantsRun2_"+i+".gif");
  }
for (int i = 0; i < handsCount; i++){
    hands[i] = loadImage("hands_"+i+".gif");
  }
for (int i = 0; i < watchCount; i++){
    watch[i] = loadImage("watch_"+i+".gif");
  }
for (int i = 0; i < hatCount; i++){
    hat[i] = loadImage("hat_"+i+".gif");
  }
for (int i = 0; i < underShirtCount; i++){
    underShirt[i] = loadImage("underShirt_"+i+".gif");
  }
for (int i = 0; i < overShirtCount; i++){
    overShirt[i] = loadImage("overShirt_"+i+".gif");
  }
for (int i = 0; i < tieCount; i++){
    tie[i] = loadImage("tie_"+i+".gif");
  }
for (int i = 0; i < collarCount; i++){
    collar[i] = loadImage("collar_"+i+".gif");
  }
for (int i = 0; i < sweaterVestCount; i++){
    sweaterVest[i] = loadImage("vest_"+i+".gif");
  }
for (int i = 0; i < jacketCount; i++){
    jacket[i] = loadImage("jacket_"+i+".gif");
  }
for (int i = 0; i < outerCoatCount; i++){
    outerCoat[i] = loadImage("outerCoat_"+i+".gif");
  }
for (int i = 0; i < scarfCount; i++){
    scarf[i] = loadImage("scarf_"+i+".gif");
  }
  
for (int i = 0; i < coinCount; i++){
    coin[i] = loadImage("coin_"+i+".gif");
  }
for (int i = 0; i < titleCount; i++){
    ragzTitle[i] = loadImage("ragzTitle_"+i+".gif");
}
////////////////////Load Music/Audio////////////////

  minim = new Minim(this);
  sndJump = minim.loadSample("jump.wav");
  sndCoin = minim.loadSample("coin.wav");
  life = minim.loadSample("life.wav");
  click = minim.loadSample("click.wav");
  tick = minim.loadSample("tick.wav");
  titleMusic = minim.loadFile("titleMusic.mp3");
  customizeMusic = minim.loadFile("customizeMusic.mp3");
  gameMusic = minim.loadFile("gameMusic.mp3");
  gameOver = minim.loadFile("gameOver.mp3");
  howToCredits = minim.loadFile("howToCredits.mp3");

///////////////////change app icon/////////////////////////

PGraphics icon = createGraphics(32, 32, JAVA2D);
icon.beginDraw();
icon.image(iconHead,0,0,32,32);
icon.endDraw();
frame.setIconImage(icon.image);  


////////////////////Load reset, etc////////////

  resetGame();
    
  cameraOffsetX = 0.0;
  
}

void resetGame() {
  
  thePlayer.reset(); // reset the coins collected number, etc.  
  theWorld.reload(); // reset world map
}

void outlinedText(String sayThis, float atX, float atY) {
  fill(255);
  text(sayThis, atX,atY);
}

void updateCameraPosition() {

  //set "camera" to follow character within world grid boundary
  
  int rightEdge = World.GRID_UNITS_WIDE*World.GRID_UNIT_SIZE-width;
  
  cameraOffsetX = thePlayer.position.x-width*.5;
  if(cameraOffsetX < 0) {
    cameraOffsetX = 0;
  }  
  if(cameraOffsetX > rightEdge) {
    cameraOffsetX = rightEdge;
  }
}

void draw() {
  noCursor();
  
  imageMode(CENTER);
  rectMode(CENTER);
  textAlign(CENTER);

////////////////////////monitoring//////////////////////////////
  
  println("layerSelect = "+layerSelect,"level = "+level,"menuDelay = "+menuDelay,"FR = "+frameRate,"menuSelect = "+menuSelect);
  println("camera = "+cameraOffsetX,"isOnGround = "+thePlayer.isOnGround);
/////////////////////////Text Flashing///////////////////////////  
  
  blinker -= 8.4;

  if(blinker < 0) {
  blinker = 255;
  }

  if (blinker > 125) {
    flash = 255;
  } else {
    flash = 0;
  }
///////////////////////Eye Blinking///////////////////////////

    blink+=2;
  if(blink == 1000) {
    blink = 0;
  }
  
///////////////////////Menu Timer and reset if left alone//////////////////////////

    if(menuDelay == 4000 && level == 1 || menuDelay == 4000 && level == 3 || menuDelay > 500 && level == 4) {
      level = 0;
      start = false;
      choice = false;
      select = false;
      menuDelay = 0;
      layerSelect = 0;
      fade = 75;
      sockCall=shoeCall=undiesCall=pantsCall=underShirtCall=watchCall=handsCall=hatCall=overShirtCall=tieCall=sweaterVestCall=collarCall=jacketCall=outerCoatCall=scarfCall = 0;
      thePlayer.reset(); // reset the coins collected number, etc.  
      theWorld.reload(); // reset world map
    }

///////////////////////constraints///////////////////

lives = constrain(lives,0,3);
sockCall = constrain(sockCall,0,9);
shoeCall = constrain(shoeCall,0,8);
undiesCall = constrain(undiesCall,0,11);
pantsCall = constrain(pantsCall,0,24);
watchCall = constrain(watchCall,0,1);
handsCall = constrain(handsCall,0,3);
hatCall = constrain(hatCall,0,2);
underShirtCall = constrain(underShirtCall,0,34);
overShirtCall = constrain(overShirtCall,0,48);
tieCall = constrain(tieCall,0,13);
sweaterVestCall = constrain(sweaterVestCall,0,8);
collarCall = constrain(collarCall,0,48);
jacketCall = constrain(jacketCall,0,14);
outerCoatCall = constrain(outerCoatCall,0,10);
scarfCall = constrain(scarfCall,0,4);

/////////////////////////music///////////////////////////

musicControl();

////////////////frameRate control///////////////////////

if(level != 3) {
  frameRate(30);
  menuDelay+=2;
}else{
  frameRate(60);
  menuDelay++;
}

///////////////////////game menu////////////////////////

switch(level) {  
  case LEVEL_TITLE:
  background(0,255,0);

  menuSelect = constrain(menuSelect,0,2);

if(menuDelay > 20 && menuDelay < 175) { 
  noStroke();
  fill(255,84,0);
  rect(width*.5,height*.5+2,width,3); 
  textSize(20);
  fill(255);
  text("ONE LINE®",width*.5,height*.5);
  text("\nPresents",width*.5,height*.5-10);
  }
  
if(menuDelay > 200) {
  
  fade+=2;
  fade = constrain(fade,0,255);
  
  image(painter,width*.5,height*.33,450,300);
  if(fade>75 && fade < 107){
    titleFrame=0;
  } else if ( fade >107 && fade < 139){
    titleFrame=1;
  } else if( fade >139 && fade < 171) {
    titleFrame=2;
  }else if(fade > 171 && fade < 255){
    titleFrame=3;
  }

    tint(255);
    image(ragzTitle[titleFrame],width*.5,height*.33,450,300);
    
  if(start == true && fade < 200) {
    start = false;
  }
  
  if(fade > 200) {
  textSize(30);
  fill(255);
  text("START\nHOW TO PLAY\nCREDITS",width*.5,height*.64);
  textSize(20);
  text("TM AND © 1986 ONE LINE®",width*.5,height*.88); 

    textSize(30);
  if(menuSelect == 0) {
    text("<",width*.7,height*.64);
  } else if (menuSelect == 1) {
    text("\n<",width*.7,height*.64);
  } else if (menuSelect == 2) {
    text("\n\n<",width*.7,height*.64);
  }
  
//button control

if (start == true) {
    menuDelay = 0;
    start = false;
if( menuSelect == 0) {
  level = 1;
} 
if(menuSelect == 1) {
  level = 5;
}
if(menuSelect == 2) {
  level = 6;
}
}
}  

  
//plash screen no hands reset
  if (menuDelay == 2000) {
    menuDelay = 0;
    fade = 75;
  }
  }
  break;
  
///////////////////////customize screen///////////////////////
  
  case LEVEL_CUSTOMIZE:
         
  background(0,255,0);
  
  fill(228,0,96);
  rect(width*.2,height*.52,206,456);
  fill(228,96,24);
  rect(width*.2,height*.52,200,450);
  fill(252,56,0);
  rect(width*.66,height*.52,426,456);
  fill(88,248,156);
  rect(width*.66,height*.52,420,450);
 
  fill(255,flash);
  textSize(30);
  text("CUSTOMIZE THE PLAYER CHARACTER!",width*.5,45);

menuDisplay();
thePlayer.draw();

break;

/////////////////////level about to start///////////////////

case LEVEL_LEADIN:

background(0,255,0);
textSize(30);
fill(255);
text("LEVEL 1-1\n\n\nCOLLECT THE FUNDZ",width*.5,height*.4);

if(menuDelay > 240){
 start= false;
level = 3;
menuDelay = 0;
}

break;

/////////////////////////game screen turn on//////////////////

  case LEVEL_GAME:
  
  background(0,255,255); 
  tint(255);

//background that follows player (illusion of distance)

  for(int i = 0; i < width*2;i=i+400) {
  image(cloud,width*.5-0.05*thePlayer.position.x+i,48,48,48);
  image(cloudFar,width*.2-0.01*thePlayer.position.x+i-100,192,48,48);
  }
  for(int i = 0; i < width*1.5;i=i+192) {
  image(worldBackgroundFar,96-0.01*thePlayer.position.x+i,510,192,192);
  image(worldBackground,96-0.05*thePlayer.position.x+i,510,192,192);    
  }
  
  pushMatrix();
  translate(-cameraOffsetX,24.0); // affects all upcoming graphics calls, until popMatrix
  
  rectMode(CORNER);
  imageMode(CORNER);
  
  updateCameraPosition();
  theWorld.render();
  thePlayer.inputCheck();
  thePlayer.draw();
  thePlayer.move();
  
  popMatrix(); // undoes the translate function from earlier in draw()
  
  noStroke();
  fill(255,84,0);
  rect(0,0,width,24);
    textAlign(LEFT); 
    outlinedText("Coins: "+thePlayer.coinsCollected,9, 24);
    textAlign(RIGHT);
    outlinedText("Lives: "+lives,width-9,24);

// death
  if (lives == 0) {
    thePlayer.coinsCollected = 0;
    level = 4;
    lives = 3;
    menuDelay = 0;
    start = false;
  }
  
break;

///////////////////////game over///////////////////////

  case LEVEL_GAMEOVER:
    
    background(0,255,0);
    
    fill(255,flash);
    text("GAME OVER",width*.5,height*.5);
    sockCall=shoeCall=undiesCall=pantsCall=underShirtCall=watchCall=handsCall=hatCall=overShirtCall=tieCall=sweaterVestCall=collarCall=jacketCall=outerCoatCall=scarfCall = 0;
    
break;

case LEVEL_HOWTO:
  
  background(0,255,0);
  noStroke();
  fill(255,84,0);
  rect(width*.5,height*.55,681,436);
  fill(0,255,0);
  rect(width*.5,height*.55,675,430);

  textSize(30);
  fill(255);
  text("HOW TO PLAY",width*.5,height*.1);
  textSize(20);
  text("Dress the artist in his RAGZ before you head out into the wasteland to collect funding!\n\nNavigate the customization screen with the ARROW KEYS/JOYSTICK/D-PAD and when you are all set, press the ENTER/RETURN/A BUTTON to confirm you selection.\n\nOnce in the RAGZ wasteland, move around with the ARROW KEYS/JOYSTICK/D-PAD and jump by pressing the SPACEBAR/A BUTTON.\n\nCan you gather up all of the grant money to make better art, or will you fall to your death without any coin!?",width*.5,height*.58,650,400);
  
if (start == true) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  } else if (menuDelay == 2300) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  }
  
break;

case LEVEL_CREDITS:
  
  background(0,255,0);
  noStroke();
  fill(255,84,0);
  rect(width*.5,height*.5,681,406);
  fill(0,255,0);
  rect(width*.5,height*.5,675,400);

  textSize(30);
  fill(255);
  text("CREDITS",width*.5,height*.1);
  textSize(20);
  text("-PROGRAMMING & GRAPHICS-\nANTHONY MONTUORI\nPLATFORMER ENGINE MODIFIED FROM CODE\nBY Chris DeLeon",width*.5,height*.25);
  text("-AUDIO-\nNYAN CAT 8-BIT by SWABASOC\nCUSTOMIZATION MUSIC - The Goonies II (KONAMI)\nBED INTRUDER 8-BIT by Ralph Vickers\nHOW TO AND CREDITS MUSIC - Rainbow Islands:\nThe Story of Bubble Bobble 2 (Taitos)\nGAMEOVER MUSIC - Double Dragon II: The Revenge\n(Technos Japan) ",width*.5,height*.47);
  
  text(versionNumber,width*.5,height*.95);
  
if (start == true) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  } else if (menuDelay == 2300) {
    level = 0;
    menuDelay = 200;
    fade = 75;
    start = false;
    menuSelect = 0;
  }
    
break;
}
}